# -*- coding: utf-8 -*-
"""
Created on Wed Jun  7 12:07:51 2023

@author: Mathieu Cancade
"""
import matplotlib.pyplot as plt

from math import sin
from math import pi

#On définit l'équation différentielle à étudier
def f(t,x,xprime):
    return -(0.2*xprime+sin(x))
    
t0=0
x0=pi/10
x0prime=0
T=50
p=0.002

temps=t0

def Euler(f,t0,x0,x0prime,T,p):
    n=int(T/p)
    t=t0
    x=x0
    xprime=x0prime
    temps=[t0]
    L=[x0]
    P=[x0prime]
    for i in range(1,n+1):
        t=t+i*p
        x,xprime=x+p*xprime,xprime+p*f(t,x,xprime)
        temps.append(t)
        L.append(x)
        P.append(xprime)
    plt.plot(temps, L)
    plt.show()
    return L,P

Euler(f,t0,x0,x0prime,T,p)

# L est la liste des x et P la liste des xprime en fct du temps
L=[[pi/10,0]]

# Pour le tracé du portrait de phase :
def Eulerphase(f,t0,L,T,p):
    for k in range(0,len(L)):
        plt.plot(Euler(f,t0,L[k][0],L[k][1],T,p)[0],Euler(f,t0,L[k][0],L[k][1],T,p)[1])
    plt.show()

